package
{
	import flash.geom.Point;
	
	import org.flixel.FlxButton;
	import org.flixel.FlxG;
	import org.flixel.FlxGroup;
	import org.flixel.FlxPoint;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxText;

	public class GameState extends FlxState
	{
		public static var hudGroup:FlxGroup;
		public static var tempGroup:FlxGroup;
		public static var t:TreeNode;
		public static var treeGroup:FlxGroup;
		public static var selected:TreeNode;
		public static var a:FlxSprite;
		public static var leftText:FlxText;
		
		public static var thisref:GameState;
		public static var specification:Array;
		public static var backgroup:FlxGroup;
		
		public static function regenTree():void
		{
			for (i=0;i<treeGroup.members.length;i++)
			{
				treeGroup.members[i].kill();
			}
			treeGroup.members=[];
			t = TreeNode.generateTree(specification,1,1);
			var v:Vector.<FlxGroup> = t.getWidgets();
			for (var i:int=0;i<v.length;i++)
			{
				treeGroup.add(v[i]);
			}
		}		

		public static function getNode(path:Vector.<int>):TreeNode
		{
			var cur:TreeNode = t;
			for (var i:int=0;i<path.length;i++)
			{
				cur=cur.children[path[i]-1];
			}
			return cur;
		}
		
		
	
		override public function create():void
		{				
			thisref=this;
			bgColor = 0xFFEEEEFF;
			specification=[1];
			
			treeGroup = new FlxGroup();			
			this.add(treeGroup);
			
			regenTree();
			
			a = new FlxSprite(t.button.x-100+t.button.width/2,t.button.y);
			FlxG.follow(a,2);
			t.button.on=true;
			
			hudGroup = new FlxGroup();
			
			hudGroup.scrollFactor.x=0;
			hudGroup.scrollFactor.y=0;
			
			var rightPanel:FlxSprite = new FlxSprite(0,0);
			
			rightPanel.createGraphic(200,FlxG.height,0xff444499);
			rightPanel.scrollFactor.x=0;
			rightPanel.scrollFactor.y=0;
			
			leftText = new FlxText(1,1,198);
			leftText.scrollFactor.x=0;
			leftText.scrollFactor.y=0;
			
			this.add(rightPanel);
			this.add(leftText);
			
			
			this.add(hudGroup);
			
			
			selectNode(t);
			//hudGroup
			/*
			tempGroup = new FlxGroup;
			for (i=5;i<10;i++)
			{
				var b:FlxButton = new FlxButton(i*20,0,null);	
				var s1:FlxSprite = new FlxSprite(0,0);
				s1.createGraphic(10,10,0xff444444);
				var s2:FlxSprite = new FlxSprite(0,0);
				s2.createGraphic(10,10,0xff999999);		
				b.loadGraphic(s1,s2);
				var t:FlxText = new FlxText(0,0,10,i.toString());
				t.color=0xff000000;
				b.loadText(t,t);
				//b.scrollFactor=new FlxPoint(0,0);
				this.add(b);
			}
			tempGroup.y=20;
			this.add(tempGroup);
			*/
		}
		
		public function GameState()
		{			
			super();
		}
		
		public static function selectNode(n:TreeNode):void
		{
			for (i=0;i<hudGroup.members.length;i++)
			{
				hudGroup.members[i].kill();				
			}
			hudGroup.members=[];
			
			GameState.a.x=n.button.x-100+n.button.width/2;
			GameState.a.y=n.button.y;
			GameState.selected=n;
			//FlxG.follow(button);
			GameState.t.offButtons();
			n.button.on=true;
			
			var s:String="";
			s+=Data.data[GameState.selected.label][1].toUpperCase()+"\n\n---------------\n\nCONFLICT\n\n";
			s+=Data.data[GameState.selected.label][2]+"\n\nRESOLUTION\n\n";
			s+=Data.data[GameState.selected.label][3]+"\n\n";
			
			const midpoint:Number=FlxG.height/2+130;
			
			if (Data.data[GameState.selected.label][4].length>0)
			{
				var moreTxt:FlxText = new FlxText(0,midpoint,200,"Can contain:");			
				moreTxt.scrollFactor.x=0;
				moreTxt.scrollFactor.y=0;
				GameState.hudGroup.add(moreTxt);
	
				trace("adding button stuff with path " + n.path.toString());
				for (var i:int=0;i<Data.data[GameState.selected.label][4].length;i++)
				{
					
					var toAdd:AddButtonAction = new AddButtonAction(Data.data[Data.data[GameState.selected.label][4][i]][0],n.path.concat());
					var btn:FlxButton = new FlxButton(0,midpoint+20+i*20,toAdd.OnClick);
					var s1:FlxSprite = new FlxSprite(0,0);
					s1.createGraphic(200,20,0xff444444);
					var s2:FlxSprite = new FlxSprite(0,0);
					s2.createGraphic(200,20,0xff999999);		
					btn.loadGraphic(s1,s2);
					var t:FlxText = new FlxText(0,0,200,Data.data[Data.data[GameState.selected.label][4][i]][1]);
					t.color=0xffffffff;
					t.scrollFactor.x=0;
					t.scrollFactor.y=0;
					btn.scrollFactor.x=0;
					btn.scrollFactor.y=0;
					btn.add(t);
					GameState.hudGroup.add(btn);				
				}
			}
			leftText.text=s;
		}
		

		override public function update():void
		{		
			if (FlxG.mouse.x>200)
			{				
				GameState.treeGroup.update();
			}
			AddButtonAction.lastclick+=FlxG.elapsed;
			if (FlxG.keys.justPressed("UP"))
			{
				if (GameState.selected.parent)
				{
					selectNode(GameState.selected.parent);
				}
			}
			else if (FlxG.keys.justPressed("DOWN"))
			{
				if (GameState.selected.children.length>0)
				{
					selectNode(GameState.selected.children[0]);
				}				
			}
			else if (FlxG.keys.justPressed("LEFT"))
			{
				if (GameState.selected.parent)
				{
					var k:int = GameState.selected.parent.children.indexOf(selected);
					if (k>0)
					{
						k--;
						selectNode(GameState.selected.parent.children[k]);
					}
				}
			}
			else if (FlxG.keys.justPressed("RIGHT"))
			{
				if (GameState.selected.parent)
				{
					k = GameState.selected.parent.children.indexOf(selected);
					if (k<GameState.selected.parent.children.length-1)
					{
						k++;
						selectNode(GameState.selected.parent.children[k]);
					}
				}				
			}
			
			a.update();
			super.update();
		}
	}
}

import org.flixel.FlxButton;
import org.flixel.FlxG;
import org.flixel.FlxGroup;
import org.flixel.FlxSprite;
import org.flixel.FlxState;
import org.flixel.FlxText;

class ClickHandler
{
	public var node:TreeNode;
	
	public function ClickHandler(_node:TreeNode)
	{
		node=_node;
	}
	
	public function onClick():void
	{	
		GameState.selectNode(node);		
	}
}

class AddButtonAction
{
	public var label:int;
	static public var path:Vector.<int>;
	static public var lastclick:Number;
	public function AddButtonAction(_label:int,_path:Vector.<int>)
	{
		label=_label;
		trace( " Label before --- " + label.toString());
		path=_path.concat();
		lastclick=0;	
	}
	public function OnClick():void
	{		
		
		if (lastclick<0.1)
			return;
		lastclick=0;
		
		var curloc:Array = GameState.specification;
		
		for (var i:int=0;i<path.length;i++)
		{
			curloc = curloc[path[i]];
		}
		curloc.push([label]);
				
		var grpvect:Vector.<FlxGroup> = GameState.t.getWidgets();
		for (i=0;i<grpvect.length;i++)
		{
			grpvect[i].kill();
			
		}
		GameState.regenTree();
		var tn:TreeNode = GameState.getNode(path);
		GameState.selectNode(tn);
	}
}
class TreeNode
{
	public const buttonwidth:Number=120;
	public const buttonheight:Number=30;
	public const padding:Number=20;
	public const ypadding:Number=40;
	public var label:int;
	public var path:Vector.<int>;
	public var button:FlxButton;
	public var children:Vector.<TreeNode>;
	public var childConnectors:Vector.<FlxSprite>;
	public var parent:TreeNode;
	public var x:Number;
	public var y:Number;
	
	public static function generateTree(_a:Array,_x:Number,_y:Number):TreeNode
	{
		var t:TreeNode = new TreeNode(new Vector.<int>,_a,null);

		t.setLeft(_x);
		
		t.setTop(_y);			
		
		return t;
	}
		
	public function setLeft(_x:Number):void
	{
		x=_x;
		var w:Number=this.calcWidth();
		this.button.x = _x + w/2 - this.buttonwidth/2;
		var curleft:Number=_x;
		for (var i:int=0;i<children.length;i++)
		{			
			children[i].setLeft(curleft);
			curleft+=children[i].calcWidth()+this.padding;
		}
	}
	
	public function setTop(_y:Number):void
	{
		y=_y;
		this.button.y=_y;
		if (children.length==1)
		{
			this.children[i].setTop(_y+this.buttonheight+this.ypadding/2);
		}
		else
		{
			for (var i:int=0;i<this.children.length;i++)
			{
				this.children[i].setTop(_y+this.buttonheight+this.ypadding);
			}
		}
	}
	
	public function offButtons():void
	{
		this.button.on=false;
		for (var i:int=0;i<this.children.length;i++)
		{
			this.children[i].offButtons();
		}
	}	
		
	
	public function TreeNode(_path:Vector.<int>,_a:Array,_p:TreeNode):void
	{
		super();
		this.path=_path;
		
		//_a[0] is always the label
		childConnectors = new Vector.<FlxSprite>;

		parent=_p;
		label=_a[0];
		children = new Vector.<TreeNode>;
		
		for (var i:int=1;i<_a.length;i++)
		{
			var tempv:Vector.<int> = new Vector.<int>;
			tempv.push(i);
			children.push(new TreeNode(_path.concat(tempv),_a[i],this));
		}				
		
		var v:ClickHandler = new ClickHandler(this);
		
		button = new FlxButton(0,0,v.onClick);
		button.leftmask=true;
		var s1:FlxSprite = new FlxSprite(0,0);
		s1.createGraphic(buttonwidth,buttonheight,0xff444444);
		var s2:FlxSprite = new FlxSprite(0,0);
		s2.createGraphic(buttonwidth,buttonheight,0xff999999);		
		button.loadGraphic(s1,s2);
		var t:FlxText = new FlxText(0,0,this.buttonwidth,Data.data[label][1]);
		t.color=0xffffffff;
		button.add(t);
	}
	
	public function getWidgets():Vector.<FlxGroup>
	{
		generateConnectors();
		var v:Vector.<FlxGroup> = new Vector.<FlxGroup>;
		v.push(button);
		for (var i:int=0;i<this.children.length;i++)
		{
			v=v.concat(children[i].getWidgets());
		}
		return v;
	}
	
	public function generateConnectors():void
	{
		for (var i:int=0;i<childConnectors.length;i++)
		{
			this.button.remove(childConnectors[i],true);
			childConnectors[i].kill();
			childConnectors[i]=null;
		}
		childConnectors = new Vector.<FlxSprite>;
		
		var w:Number = this.calcWidth();
		
		if (children.length>0)
		{
			var b1:FlxSprite = new FlxSprite(buttonwidth/2,buttonheight);
			b1.createGraphic(1,ypadding/2+1,0xff000000);
			childConnectors.push(b1);
			b1.moves=false;
			this.button.add(b1);	
			
			if (children.length>1)
			{
				b1 = new FlxSprite(buttonwidth/2,buttonheight);
				b1.createGraphic(1,ypadding/2+1,0xff000000);
				childConnectors.push(b1);
				b1.moves=false;
				this.button.add(b1);
				var wleftmost:Number = children[0].calcWidth();
				var wrightmost:Number = children[children.length-1].calcWidth();
				var b2:FlxSprite = new FlxSprite(buttonwidth/2-w/2+wleftmost/2,buttonheight+ypadding/2);
				b2.createGraphic(w-wleftmost/2-wrightmost/2,1,0xff000000);
				childConnectors.push(b2);
				b2.moves=false;
				this.button.add(b2);
			
				var left:Number = buttonwidth/2-w/2;
				for (i=0;i<children.length;i++)
				{
					var wInner:Number = children[i].calcWidth();
					var b3:FlxSprite = new FlxSprite(left+wInner/2,buttonheight+ypadding/2+1);
					b3.createGraphic(1,ypadding/2,0xff000000);
					this.button.add(b3);
					left+=wInner+padding;
				}
			}			
		}
	}
	
	public function calcWidth():Number
	{
		if (children.length==0)
		{
			return buttonwidth;
		}
		else
		{
			var n:Number=0;
			for (var i:int=0;i<children.length;i++)
			{
				if (i>0)
					n+=padding;
				n+=children[i].calcWidth()
			}
			return n;
		}		
	}
	
	
	
	public function calcHeight():Number
	{
		if (children.length==0)
		{
			return buttonheight;
		}
		else if (children.length==1)
		{
			return ypadding/2 + children[i].calcHeight();
		}
		else
		{
			var curMax:Number=0;
			for (var i:int=0;i<children.length;i++)
			{
				curMax=Math.max(curMax,children[i].calcHeight());
			}
			return + ypadding;
		}		
	}
	
}